package de.limited_dev.lil_judd.consolecommand.system;

import de.limited_dev.lil_judd.consolecommand.component.ConsoleCommand;
import de.limited_dev.lil_judd.features.planner.TimePlanner;
import net.dv8tion.jda.api.entities.Guild;
import net.dv8tion.jda.api.entities.GuildVoiceState;
import net.dv8tion.jda.api.entities.Member;
import net.dv8tion.jda.api.managers.AudioManager;

public class ShutdownCommand extends ConsoleCommand {
    public ShutdownCommand() {
        super("shutdown", "Shut the bot down", null);
    }

    @Override
    public void onCommand(String[] args) {
        lgr.consoleOut("Shutting down...");
        for(Guild g : jda.getSelfUser().getMutualGuilds()){
            Member self = g.getSelfMember();
            GuildVoiceState selfState = self.getVoiceState();
            if(selfState.inAudioChannel()){
                AudioManager audioManager = g.getAudioManager();
                lgr.consoleOut("Leaving VC " + audioManager.getConnectedChannel().asVoiceChannel().getName() + " in " + g.getName());
                audioManager.closeAudioConnection();
            }
        }
        TimePlanner.schedulerFirstLesson.shutdown();
        jda.shutdown();
    }
}
