package de.limited_dev.lil_judd.jdacommands.management;

import de.limited_dev.lil_judd.jdacommands.components.JDACommand;
import de.limited_dev.lil_judd.features.planner.TimePlanner;
import de.limited_dev.lil_judd.util.EmbeddedMessageHelper;
import net.dv8tion.jda.api.Permission;
import net.dv8tion.jda.api.events.interaction.command.SlashCommandInteractionEvent;

public class SetupFeatureCommand extends JDACommand {
    public SetupFeatureCommand() {
        super("setup");
    }

    @Override
    public void onSlashCommand(SlashCommandInteractionEvent event) {
        if(!event.getGuild().getMemberById(event.getUser().getIdLong()).hasPermission(Permission.ADMINISTRATOR)){
            EmbeddedMessageHelper.sendSimpleOneLiner(event, "403: Forbidden", "You are not allowed to run this command.", null);
            return;
        }
        if(event.getOption("feature").getAsString().equals("timefinder")){
            TimePlanner.getGtps().guildsWithPlanner.put(event.getGuild().getIdLong(), event.getOption("channel").getAsChannel().getIdLong());
            TimePlanner.getGtps().save();
            EmbeddedMessageHelper.sendSimpleOneLiner(event, "Channel has been selected for the ritual",
                    "The Channel has been added. You may now recieve notifications", null);
        }
    }
}
